<template>
  <div class="app-container">
    <div class="filter-container">
      <!-- <el-input v-model="listQuery.keyword" size="small" placeholder="请输入关键词" clearable class="filter-item w-200" /> -->
      <el-button-group class="filter-item">
        <!-- <el-button size="small" type="primary" icon="el-icon-search" @click="search">
          搜索
        </el-button> -->
        <el-button size="small" type="primary" icon="el-icon-refresh" @click="refresh">
          刷新
        </el-button>
        <!-- <el-button size="small" type="primary" icon="el-icon-plus" @click="add">
          新增
        </el-button> -->
      </el-button-group>
    </div>

    <el-table v-loading="listLoading" :data="list" element-loading-text="Loading" border fit height="100%"
      class="table-container" highlight-current-row>
      <el-table-column fixed label="序号" width="80" >
        <template slot-scope="scope">
          {{ scope.row.id }}
        </template>
      </el-table-column>
      <el-table-column label="导航名称" >
        <template slot-scope="scope">
          {{ scope.row.title }}
        </template>
      </el-table-column>
      <el-table-column label="自身级别" >
        <template slot-scope="scope">
          {{ scope.row.parent }}
        </template>
      </el-table-column>
      <el-table-column label="关联级别" >
        <template slot-scope="scope">
          {{ scope.row.childrenid }}
        </template>
      </el-table-column>
      <!-- <el-table-column label="层级" >
        <template slot-scope="scope">
          {{ scope.row.level }}
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="是否显示" >
        <template slot-scope="scope">
          {{ scope.row.ishow }}
        </template>
      </el-table-column> -->
      <!-- <el-table-column label="图标" >
        <template slot-scope="scope">
          {{ scope.row.icon }}
        </template>
      </el-table-column> -->
      <el-table-column label="添加时间" >
        <template slot-scope="scope">
          {{ scope.row.addtime }}
        </template>
      </el-table-column>
      <el-table-column  label="操作" width="200"  v-if="uupdate=='Yes'">
        <template slot-scope="scope">
          <el-button-group>
            <el-button  type="primary" icon="el-icon-edit" size="mini" @click="edit(scope)">
              修改
            </el-button>
            <!-- <el-button type="danger" icon="el-icon-delete" size="mini" @click="del(scope)">
              删除
            </el-button> -->
          </el-button-group>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total > 0" :total="total" :page.sync="listQuery.current" :limit.sync="listQuery.size"
      @pagination="fetchData" />

    <el-dialog :visible.sync="dialogVisible" :title="dialogType === 'modify' ? '修改' : '新增'">
      <el-form :ref="temp" :model="temp" label-width="120px" label-position="right" :rules="rules">
        <el-form-item label="导航名称" prop="title">
          <el-input v-model="temp.title
          " placeholder="请输入导航名称" />
        </el-form-item>
        <!-- <el-form-item label="是否显示">
          <el-switch v-model="temp.ishow" active-color="#13ce66" active-value="1" inactive-value="0"
            inactive-color="#ff4949">
          </el-switch>
        </el-form-item> -->
        <!-- <el-form-item label="图标">
          <el-input v-model="temp.icon
          " placeholder="请输入图标" />
        </el-form-item> -->

        <el-form-item label="角色权限">
          <el-checkbox-group v-model="checkList" >
            <el-checkbox label="超级管理员" disabled></el-checkbox>
            <el-checkbox label="普通管理员" @change="onchange1"></el-checkbox>
            <el-checkbox label="访客" @change="onchange2"></el-checkbox>
            <!-- <el-checkbox label="禁用" disabled></el-checkbox>
    <el-checkbox label="选中且禁用" ></el-checkbox> -->
          </el-checkbox-group>
        </el-form-item>
      </el-form>
      <div class="text-right">
        <el-button type="danger" @click="dialogVisible = false">
          取消
        </el-button>
        <el-button type="primary" @click="submit">
          确定
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'
import { getMenusPage, delMenus, addorupMenus, searchMenus, addSystemOperationLog } from '@/api/menus'
import { deepClone } from '@/utils'

const _temp = {
  name: '',
  id: '',
  title: '',
  ishow: '',
  icon: '',
  ispg: '',
  isfk: '',
}

export default {
  components: {
    Pagination
  },
  data() {
    return {
      uadd:'',
      udelete:'',
      uupdate:'',
      checkList: ['超级管理员'],
      total: 0,
      list: [],
      menus: [],
      listLoading: true,
      listQuery: {
        current: 1,
        size: 20,
        keyword: undefined,
      },
      uploadUrl: '',
      temp: Object.assign({}, _temp),
      dialogVisible: false,
      dialogType: 'create',
      loading: false,
      rules: {
        title: [
          { required: true, message: '请输入导航名称', trigger: 'change' }
        ]
      },
    }
  },
  created() {
    this.fetchData()
  },
  methods: {
    onchange1(e) {
      if (e) {
        this.temp.ispg = "普通管理员"
      }else{
         this.temp.ispg = ""
      }
    },
    onchange2(e) {
      if (e) {
       this.temp.isfk = "访客"
      }else{
        this.temp.isfk = ""
      }
    },
    // 搜索
    search() {
      this.listLoading = true
      searchMenus(this.listQuery).then(response => {
        this.list = response.data.records
        this.total = response.data.total
        this.listLoading = false
      })
    },
    refresh() {
      this.listQuery = {
        current: 1,
        size: 20,
        keyword: undefined
      }
      this.fetchData()
    },
    // 分页数据
    fetchData() {
      this.uadd = localStorage.getItem('uadd') || '';
      this.udelete = localStorage.getItem('udelete') || '';
      this.uupdate = localStorage.getItem('uupdate') || '';
      this.listLoading = true
      getMenusPage(this.listQuery).then(response => {
        this.list = response.data.records
        this.total = response.data.total
        this.listLoading = false
      })
    },
    resetTemp() {
      this.temp = Object.assign({}, _temp)
    },
    // add() {
    //   this.resetTemp()
    //   this.dialogVisible = true
    //   this.dialogType = 'create'
    //   this.$nextTick(() => {
    //     this.$refs['dataForm'].clearValidate()
    //   })
    // },
    edit(scope) {
      this.resetTemp()
      this.dialogVisible = true
      this.dialogType = 'modify'
      this.temp = deepClone(scope.row)
      if (scope.row.isfk != null) {
        this.checkList.push("访客")
      }
      if (scope.row.ispg != null) {
        this.checkList.push("普通管理员")
      }
      // this.$nextTick(() => {
      //   this.$refs['dataForm'].clearValidate()
      // })
    },
    changeStatus(value, scope) {
      setTimeout(() => {
        this.list[scope.$index].status = value
        this.$message({
          message: '更新成功',
          type: 'success'
        })
      }, 300)
    },
    // 删除
    del(scope) {
      this.$confirm('确认删除该条数据吗？', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        setTimeout(() => {
          const params = { id: scope.row.id };
          this.list.splice(scope.$index, 1)
          delMenus(params).then(response => {
            this.$message({
              message: '删除成功',
              type: 'success'
            })
            this.fetchData()
          })
        }, 300)
      })
    },
    submit() {
      if (this.checkList) {

      }
      if (this.loading) {
        return
      }
      this.loading = true
      this.$refs[this.temp].validate((valid) => {
        if (valid) {
          addorupMenus(this.temp).then(() => {
            this.temp.adminname = localStorage.getItem('username') || '';
            const params = { name: this.temp.adminname, content: '修改了一个后台导航，该导航名称为：' + this.temp.title };
            addSystemOperationLog(params).then(response => {

            })
            this.fetchData()
            setTimeout(() => {
              this.$message({
                message: '提交成功',
                type: 'success'
              })
              this.dialogVisible = false
              this.loading = false
            }, 300)
          })
        } else {
          this.$message({
            message: '提交失败，请检查表单必填项是否为空',
            type: 'error'
          })
          console.log('error submit!!');
          return false;
        }
      });
    }
  }
}
</script>

<style lang="scss" scoped>
.el-upload {
  border: 1px dashed #d9d9d9 !important;
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;

  .el-icon-plus.avatar-uploader-icon {
    border: 1px dashed #d9d9d9 !important;
    border-radius: 6px;
    font-size: 28px;
    color: #8c939d;
    width: 128px;
    height: 128px;
    line-height: 128px;
    text-align: center;
  }
}

.avatar-uploader {
  height: 128px;

  img {
    width: 128px;
    height: 128px;
  }
}
</style>
